/*----------------------------------------------------------------------+
|									|
| Copyright (C) 2016 LA Solutions Ltd, 			|
| All rights reserved.							|
|									|
+----------------------------------------------------------------------*/
#if !defined(FILE_COLLECTOR_H_INCLUDED_)
#define FILE_COLLECTOR_H_INCLUDED_

#define WINVER 0x0601 	//	_WIN32_WINNT_WIN7
#define _WIN32_WINNT 0x0601	//	_WIN32_WINNT_WIN7

/*----------------------------------------------------------------------+
|                                                                       |
|   FileCollector - FileCollector source code. |
|                                                                       |
+----------------------------------------------------------------------*/
#include	<Mstn\MicroStation.r.h>
#include	<DgnPlatform\DgnPlatform.r.h>

enum MessageListIDs
{
	MESSAGELIST_Captions,
	MESSAGELIST_Commands,
	MESSAGELIST_Errors,
	MESSAGELIST_Messages,
	MESSAGELIST_Misc,
	MESSAGELIST_Prompts,
};

enum CmdMessageIDs
{
    COMMAND_ToolSettings,
    COMMAND_PlaceDate,
};

enum PromptMessageIDs
{
    PROMPT_abc,
    PROMPT_EnterPoint,
};

enum ErrorMessageIDs
{
    ERROR_RootPathEmpty,
    ERROR_RootPathInvalid,
};

enum MiscellaneousIDs
{
	MISC_abc					= 10,
};

enum MessageIDs
{
    MESSAGE_Recurse,
    MESSAGE_RootOnly,
    MESSAGE_FileCount,
	MESSAGE_ResourceLoadError,
};

enum DialogIDs
{
	DIALOG_FileCollector,
};

enum DialogItemIDs
{
	LISTBOX_FileCollector		= 10,
	MENUBAR_MainMenuBar,
	PULLDOWNMENU_File,
	COMBOBOX_DataSheetEditor,
	TEXT_InitialFolder,
	PUSHBUTTON_HarvestFiles,
	MENUSEARCH_File,
	LBL_LASolutions,
	//	CheckBox also known as ToggleButton
	CHECKBOX_SubFolders,
	CHECKBOX_CAD_Files,
	CHECKBOX_WritableFiles,
};

///	<summary>Column ID used to assign file path information in a ListBox.
///	<remarks>Suppose the file path is C:\cad\design.dgn.
///	<para>Captions are stored in </para></remarks>
///	</summary>
enum	ColumnIds
{
	FileTitle	= 1,	//	title only e.g. design
	FileName,			//	title + extension e.g. design.dgn
	FilePath,			//	e.g. C:\cad
	FileExtension,		//	e.g. dgn
	TypeDescription,	//	What Windows thinks this is e.g. MicroStation Design File
	Writeable,
	IsCadFile,			//	i.e. MicroStation can edit this file
	Directory,
};

enum	CaptionIDs
{
    CAP_FileTitle		= FileTitle,
    CAP_FileName		= FileName,
    CAP_FilePath		= FilePath,
    CAP_FileExtension	= FileExtension,
    CAP_TypeDescription	= TypeDescription,
    CAP_Writeable		= Writeable,
    CAP_IsCadFile		= IsCadFile,
    CAP_Directory		= Directory,
    CAP_Dialog,
};

#define	TXT_DllName				L"FileCollector"

enum HookIDs
{
	HOOKITEM_ListBox	= 20,
};

#if !defined (resource)
typedef struct globaldata
{
	WChar				initialFolder	[DGNPLATFORM_RESOURCE_MAXQUOTEDFILELENGTH];
	int     			colorNumber;
    struct flags_
    {
		unsigned int	subFolders				: 1;
		unsigned int	cadFiles				: 1;
		unsigned int	writableFiles			: 1;
    	unsigned int	unused					:29;
    } flags;
} GlobalData;
#endif	//	!defined (resource)

#endif	// !defined(FILE_COLLECTOR_H_INCLUDED_)

