#pragma Ident "LA Solutions: FileCollector dialogs"
/*----------------------------------------------------------------------+
|									|
|   $Workfile:   datasheet  $
|   $Revision:  $
|   	$Date:  $
|									|
+----------------------------------------------------------------------*/
/*----------------------------------------------------------------------+
|                                                                       |
|   FileCollector source code. 											|
|                                                                       |
+----------------------------------------------------------------------*/

#include    <Mstn\MdlApi\dlogbox.r.h>

#include    "FileCollector.h"
#include    "FileCollectorCmd.h"
#include    <FileCollectorText.h>

DialogBoxRsc    DIALOG_FileCollector =
    {
    DIALOGATTR_DEFAULT | DIALOGATTR_MOTIONTOITEMS | DIALOGATTR_AUTOUNLOADAPP,
    	65*XC, 18*YC, NOHELP, MHELP, NOHOOK, NOPARENTID, TXT_DialogTitle,
    {
    {{0,0,0,0},MenuBar,MENUBAR_MainMenuBar, ON, 0,"",""},
    {{   XC,    D_ROW( 3), XC*62, 0}, ListBox, LISTBOX_FileCollector, ON, 0, "", ""},
	{{   XC* 8, D_ROW( 9), XC*44, 0}, Text, TEXT_InitialFolder, ON, 0, "", ""},
    {{ 1*XC,    D_ROW(11), XC*14, 0}, ToggleButton, CHECKBOX_SubFolders, ON, 0, "", ""},
    {{22*XC,    D_ROW(11), XC*14, 0}, ToggleButton, CHECKBOX_CAD_Files, ON, 0, "", ""},
    {{40*XC,    D_ROW(11), XC*14, 0}, ToggleButton, CHECKBOX_WritableFiles, ON, 0, "", ""},
    /* {{   XC,    D_ROW(12), XC*15, 0}, Label, LBL_LASolutions, ON, 0, "LA Solutions", ""}, */
	{{55*XC,    D_ROW(11), XC* 8, 0}, PushButton, PUSHBUTTON_HarvestFiles, ON, 0, "", ""},
    }
    };

DItem_MenuBarRsc MENUBAR_MainMenuBar =
    {
    NOHOOK,NOARG,
    	{
	{PulldownMenu, PULLDOWNMENU_File},
    	}
    };

DItem_ListBoxRsc      LISTBOX_FileCollector =
    {
    NOHELP, MHELP, HOOKITEM_ListBox, NOARG,
    LISTATTR_GRID | LISTATTR_INDEPENDENTCOLS | LISTATTR_HORIZSCROLLBAR | LISTATTR_RESIZABLECOLUMNS,
    6, 0, "",
    	{
	{24*XC, 256, ALIGN_CENTER, "FileTitle"			},
	{24*XC, 256, ALIGN_CENTER, "FilePath"			},
	{10*XC,  10, ALIGN_CENTER, "Writeable"			},
	{ 8*XC,   8, ALIGN_CENTER, "FileExtension"		},
	{24*XC,  48, ALIGN_CENTER, "TypeDescription"	},
    	}
    };

DItem_PushButtonRsc PUSHBUTTON_HarvestFiles =
    {
    NOT_DEFAULT_BUTTON,
    NOHELP,
    LHELP,
    NOHOOK,
    NOARG,
    CMD_HARVEST_FILES,
    LCMD,
    "",
    TXT_pBtn_HarvestAll
    };

DItem_TextRsc TEXT_InitialFolder =
   {
   NOCMD, LCMD, NOSYNONYM, NOHELP, MHELP,
   NOHOOK, NOARG,
   DGNPLATFORM_RESOURCE_MAXQUOTEDFILELENGTH, "%s", "%s", "", "", NOMASK, NOCONCAT,
   TXT_txt_InitFolder,
   "gData.initialFolder"
   };

DItem_PulldownMenuRsc   PULLDOWNMENU_File =
    {
    NOHELP,MHELP,NOHOOK,ON|ALIGN_LEFT, "File",
    	{
	/* the collect files options */
    	{"Harvest ~All", NOACCEL, ON, NOMARK,0, NOSUBMENU,NOHELP,MHELP,
	NOHOOK, MENUSEARCH_File, CMD_HARVEST_FILES, OTASKID,""},
	/* the exit option */
    	{"~Exit", NOACCEL, ON, NOMARK,0, NOSUBMENU,NOHELP,MHELP,
	NOHOOK, MENUSEARCH_File, CMD_HARVEST_EXIT, OTASKID,""},
	}

    };

DItem_ToggleButtonRsc  CHECKBOX_SubFolders =
     {
     NOCMD, LCMD, NOSYNONYM, NOHELP, MHELP,
     NOHOOK, NOARG,
     NOMASK, NOINVERT,
     TXT_CHECKBOX_SubFolders,
     "gData.flags.subFolders"
 };

DItem_ToggleButtonRsc  CHECKBOX_CAD_Files =
     {
     NOCMD, LCMD, NOSYNONYM, NOHELP, MHELP,
     NOHOOK, NOARG,
     NOMASK, NOINVERT,
     TXT_CHECKBOX_CAD_Files,
     "gData.flags.cadFiles"
 };

DItem_ToggleButtonRsc  CHECKBOX_WritableFiles =
     {
     NOCMD, LCMD, NOSYNONYM, NOHELP, MHELP,
     NOHOOK, NOARG,
     NOMASK, NOINVERT,
     TXT_CHECKBOX_WritableFiles,
     "gData.flags.writableFiles"
 };

