#include	"MicroStation.h"
#include	"FileFilterFunctors.h"
#include	<UndefineMdlMacrosThatInterfereWithBoost.h>
#include 	<boost/filesystem/operations.hpp>
#include	<string>
#include	<tstring_typedef.h>
#include	<sys/stat.h>
#include	"BoostFileSystem.h"

//////////////////////////////////////////////////////////////////////
bool	WrongVersionDgnFile::operator()(boost::filesystem::path const& fileEntry)
{
	bool					rc		(true);
	const DgnPlatform::DgnFileFormatType	Version	(MicroStation::FileFormat (fileEntry.wstring().c_str ()));
	if (DgnPlatform::DgnFileFormatType::V7 == Version && flags_ & FileCollector::DgnV7Files)
	{
		rc	= false;
	}
	else if (DgnPlatform::DgnFileFormatType::V8 == Version && flags_ & FileCollector::DgnV8Files)
	{
		rc	= false;
	}
	else if (DgnPlatform::DgnFileFormatType::DWG == Version && flags_ & FileCollector::DwgFiles)
	{
		rc	= false;
	}
	else if (DgnPlatform::DgnFileFormatType::DXF == Version && flags_ & FileCollector::DxfFiles)
	{
		rc	= false;
	}
	//else
	return rc;
}
//////////////////////////////////////////////////////////////////////
bool	CadFile::operator()(boost::filesystem::path const& fileEntry)
{
	bool					rc		(false);
	const DgnPlatform::DgnFileFormatType	Version	(MicroStation::FileFormat (fileEntry.wstring().c_str ()));
	if (DgnPlatform::DgnFileFormatType::V7 == Version && flags_ & FileCollector::DgnV7Files)
	{
		rc	= true;
	}
	else if (DgnPlatform::DgnFileFormatType::V8 == Version && flags_ & FileCollector::DgnV8Files)
	{
		rc	= true;
	}
	else if (DgnPlatform::DgnFileFormatType::DWG == Version && flags_ & FileCollector::DwgFiles)
	{
		rc	= true;
	}
	else if (DgnPlatform::DgnFileFormatType::DXF == Version && flags_ & FileCollector::DxfFiles)
	{
		rc	= true;
	}
	//else
	return rc;
}
//////////////////////////////////////////////////////////////////////
bool	IsLink::operator()(boost::filesystem::path const& fileEntry)
{	//	What goes here?
	return false;
}
//////////////////////////////////////////////////////////////////////
bool	InvalidDesignFile::operator()(boost::filesystem::path const& fileEntry)
{
	return !MicroStation::CanOpen (fileEntry.wstring().c_str ());
}
//////////////////////////////////////////////////////////////////////
bool	ReadOnlyFile::operator()(boost::filesystem::path  const& fileEntry)
{
	bool			readOnly	(true);
	struct _stat	fileInfo;
	// Attempt to get the file attributes
	if (SUCCESS == ::_stat (fileEntry.string ().c_str (), &fileInfo))
	{
		readOnly	= !(fileInfo.st_mode & _S_IWRITE);
	}
	return readOnly;
}
//////////////////////////////////////////////////////////////////////
bool	WriteableFile::operator()(boost::filesystem::path const& fileEntry)
{
	bool			writeable	(false);
	struct _stat	fileInfo;
	// Attempt to get the file attributes
	if (SUCCESS == ::_stat (fileEntry.string ().c_str (), &fileInfo))
	{
		writeable	= (fileInfo.st_mode & _S_IWRITE)? true: false;
	}
	return writeable;
}

