#if !defined(LA_MICROSTATION_H_INCLUDED_)
#define LA_MICROSTATION_H_INCLUDED_

#pragma once

#include	<Mstn/basetype.h>
#include	<Mstn/basedefs.h>
#include	<string>

namespace MicroStation
{
	////////////////////////////////////////////////////////////////////////////////////////////////////
	/// <summary>	Busy Cursor lets us change the cursor to be shown in MicroStation. </summary>
	///
	/// <remarks>	The destructor returns the cursor to its initial type</remarks>
	struct BusyCursor
	{
		BusyCursor	();
		~BusyCursor	();
	};
	///	<summary> 	Copy the value of a configuration variable into a string buffer.</summary>
	void				GetCfgVar 		(WChar* buffer, size_t size, WChar const* cfgVar);
	WString				GetCfgVar 		(WChar const* cfgVar);

	///	<summary> Attempt to find the file format of the specified file.</summary>
	Bentley::DgnPlatform::DgnFileFormatType	FileFormat	(WChar const*         	filePath,
														bool*                   is3D	= nullptr);
	///	<summary> Can MicroStation open this file?</summary>
	bool    			CanOpen                   		(WChar const*         	filePath);
	///	<summary>Set version number from a Windows resource file.
	///	<remarks>Version data is stored in FileCollector.rc.</remarks>
	///	</summary>
	void				SetVersion						(WChar const* 			dllName);
	///	<summary>The MDL way to set a version number in an MDL app.</summary>
	void    			SetVersionNumber        		(VersionNumber const& 	v);
}

#endif // !defined(LA_MICROSTATION_H_INCLUDED_)
